/* ImLib3D
 * Copyright (c) 2001, ULP-IPB Strasbourg.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/*! \file   Draw.hpp */


#ifndef _Draw_hpp
#define _Draw_hpp
#include<ImLib3D/Geometry3D.hpp>
#include<ImLib3D/ImageProcessor.hpp>

//! Pen for drawing into images
template <class Im3DValue>
class Pen
{
	Im3DValue color;
	int thickness; //not used yet
public:
	Pen(Im3DValue _color = 255, int _thickness = 1) : color(_color), thickness(_thickness)
	{
		;
	}
	const Im3DValue& Color() const { return color;}
};

//! gc for drawing into images
template <class Im3DValue>
class DrawingContext //ContainerDrawingContext 
{
	Pen<Im3DValue> pen;
public:
	DrawingContext(Pen<Im3DValue> _pen=Pen<Im3DValue>()) : pen(_pen)
	{
		;
	}
	const Pen<Im3DValue>& GetPen()const { return pen;}
};

/*! #&DrawingProcessor&# ~*/
class CDrawingProcessor : public CImageProcessor
{
	//!Base class for drawing
};

namespace IP3D
{
/*! #&DrawSegment3D&# ~*/
	template <class ImageType>
	void DrawSegment3D(const ImageType& src, const Segment3D& segment , ImageType& res, DrawingContext<	typename ImageType::value_type>* dc=NULL);
};

#include<ImLib3D/Draw.hxx>

#endif //_Draw_hpp
