/* ImLib3D
 * Copyright (c) 2001, ULP-IPB Strasbourg.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/*! \file Geometry3D.hpp */
#ifndef _Geometry3D_hpp
#define _Geometry3D_hpp

//! Line segment between 2 3D points
class Segment3D
{
public:
	Vect3Df P0;
	Vect3Df P1;
	Segment3D (Vect3Df _P0, Vect3Df _P1) : P0(_P0), P1(_P1) 
	{
		;
	}
	//!scale segment
	Segment3D& operator*=(const float& scale)
	{
		Vect3Df direction = P1-P0;
		direction *= scale;
		P1 = P0 + direction;
		return (*this);
	}
};

#endif// _Geometry3D_hpp
