/* ImLib3D
 * Copyright (c) 2001, ULP-IPB Strasbourg.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*!
  \file   NoiseEstimation.hpp
  \brief  Estimators for estimating noise in images
*/

#ifndef _NoiseEstimation_hpp
#define _NoiseEstimation_hpp

#include <ImLib3D/ImageProcessor.hpp>
#include <ImLib3D/FFT.hpp>
#include <ImLib3D/Convolution.hpp>


namespace IP3D
{
/*! #&NoiseVarianceEstimation&#     Estimates the noise in an image.
        Uses the difference of to Laplacian filters (size 3x3x3) to estimate the 
        noise variance.
     <UL>Args:
      <LI>Source image     type:Image3Df
      <LI>Result Variance  type:double
     </UL>
~*/
		void NoiseVarianceEstimation(const Image3Df& _image, double& variance);
};


#endif //_NoiseEstimation_hpp
