/* ImLib3D
 * Copyright (c) 2001, ULP-IPB Strasbourg.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/*! \file PluginManagement.hpp */

#ifndef _PluginManagement_hpp
#define _PluginManagement_hpp
#include<ImLib3D/ImageProcessorsDescription.hpp>
#include<map>

//! Full description and calling of all processors (including those in plugins)
class PluginManagement : public ImageProcessorsDescription
{
	string imlib3dExec;
	vector<string> paths;
	vector<string> pluginNames;
	vector<string> FindPlugins();
	map<string,int> imageProcessorsPluginId;
public:
	static vector<string> PluginPaths();
	int PluginNumber(const string &name);
	void ExecuteImageProcessor(const vector<string> &args);
	PluginManagement();
};



#endif // _PluginManagement_hpp
